function [p stat] = template_indtestp(x, numLevels, ord, j1, j2, j3, TestParam, PowerParam, Param)
%TEMPLATE_INDTESTP Template conditional independence test p-value estimator function
%
%  WARNING - Future versions of the toolbox may require you to update
%  custom functions.
%
%  Directions for Customizing
%
%    1. Make a copy of this function with a new name
%    2. Edit your new function according to the code comments marked ***
%    3. Type HELP ORG.MENSXMACHINA.PGM.INDTESTP to see a list of other
%       conditional independence test p-value estimator functions.
%
%   P = TEMPLATE_INDTESTP(X, NUMLEVELS, ORD, J1, J2, J3, TESTPARAM, POWERPARAM, PARAM)
%   returns an estimate P of the p-value of the test of conditional
%   independence of the null hypothesis that column J1 of matrix X is
%   independent of column J2 given column(s) J3. X is a matrix of
%   observations without any missing (NaN) values. NUMLEVELS is a numeric 
%   vector of length equal to the number of columns of X, containing their
%   number of levels where the columns of X contain categorical data in
%   numeric form (i.e. value i corresponds to the i-th level) and NaN where
%   they contain truly numeric data. ORD is a logical vector of length
%   equal to the number of columns of X, containing logical 1 (true) where
%   the columns of X contain ordinal categorical data in numeric form and
%   logical 0 (false) otherwise. J1 and J2 are positive integers and J3 is
%   a positive integer, a vector of positive integers or an empty numeric
%   array ([]). TESTPARAM is a structure of test parameters that is also
%   passed to the p-value estimator function. POWERPARAM is a structure of
%   parameters returned by the power estimation function to be reused in
%   TEMPLATE_INDTESTP. PARAM is a structure of parameters for
%   TEMPLATE_INDTESTP.
%
%   [P STAT] = TEMPLATE_INDTESTP(X, NUMLEVELS, ORD, J1, J2, J3, TESTPARAM, POWERPARAM, PARAM)
%   also returns the test statistic STAT. Note that the constraint-based
%   learning functions of this toolbox assume that the largest the absolute
%   value of the test statistic is, the more evidence against the null
%   hypothesis exists.

%   Copyright 2010-2011 Mens X Machina
%
%   This file is part of Mens X Machina Commons Toolbox.
%
%   Mens X Machina Commons Toolbox is free software: you can redistribute
%   it and/or modify it under the terms of the GNU General Public License 
%   as published by the Free Software Foundation, either version 3 of the
%   License, or (at your option) any later version.
%
%   Mens X Machina Commons Toolbox is distributed in the hope that it will
%   be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
%   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
%   General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with Mens X Machina Commons Toolbox. If not, see
%   <http://www.gnu.org/licenses/>.

% *** CUSTOMIZE HERE
% *** return the estimated p-value
p = 1;

% *** CUSTOMIZE HERE
% *** return the test statistic
stat = 0;

end