function [skeleton p stat flag Stats] = mmpcnonsym(a, var, varargin)
%MMPCNONSYM Non- symmetry corrected MMPC
%   MMPCNONSYM is called exactly like MMPC but it does not perform the
%   symmetry correction.
%
%   See also ORG.MENSXMACHINA.PGM.MMPC, ORG.MENSXMACHINA.PGM.MMPCSKELETON,
%   ORG.MENSXMACHINA.PGM.MMPCNONSYMOPT

%   Copyright 2010-2011 Mens X Machina
%
%   This file is part of Mens X Machina Probabilistic Graphical Model
%   Toolbox.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is free software:
%   you can redistribute it and/or modify it under the terms of the GNU 
%   General Public License as published by the Free Software Foundation,
%   either version 3 of the License, or (at your option) any later version.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is distributed in
%   the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
%   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
%   PURPOSE. See the GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License along
%   with Mens X Machina Probabilistic Graphical Model Toolbox. If not, see
%   <http://www.gnu.org/licenses/>.

persistent InstParam;

if isempty(InstParam)
    InstParam = mmpcgllinstparam();
end

% call GLLPCNONSYM
[skeleton p stat flag Stats] = gllpcnonsym(a, var, InstParam, varargin{:});

end