function plotpcconfusion(targetskeleton, outputskeleton, t)
%PLOTPCCONFUSION Plot parents and children confusion matrix
%
%   ORG.MENSXMACHINA.PGM.PLOTPCCONFUSION is a version of the PLOTCONFUSION
%   function in the Neural Network Toolbox (TM), specialized for parents
%   and children learning. For a given node, the task of learning its 
%   parents and children can be viewed as a binary classification task,
%   where each other node is classified as either parent or child, or not.
%   
%   PLOTSKELETONCONFUSION(TARGETSKELETON, OUTPUTPC, T) displays the 
%   classification confusion grid for the output parents and children set
%   OUTPUTPC, returned either by ORG.MENSXMACHINA.PGM.MMPC or
%   ORG.MENSXMACHINA.PGM.MMPCBAR, targeting the parents and children of
%   the variable specified by positive integer T in skeleton
%   TARGETSKELETON.
%
%   See also: PLOTCONFUSION

%   Copyright 2010-2011 Mens X Machina
%
%   This file is part of Mens X Machina Probabilistic Graphical Model
%   Toolbox.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is free software:
%   you can redistribute it and/or modify it under the terms of the GNU 
%   General Public License as published by the Free Software Foundation,
%   either version 3 of the License, or (at your option) any later version.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is distributed in
%   the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
%   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
%   PURPOSE. See the GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License along
%   with Mens X Machina Probabilistic Graphical Model Toolbox. If not, see
%   <http://www.gnu.org/licenses/>.

targets = targetskeleton(t, :);
targets(t) = []; % remove target variable

outputs = outputskeleton(t, :);
outputs(t) = []; % remove target variable

plotconfusion(targets, outputs); 

end