function [skeleton p stat flag Stats] = gllpc(a, var, InstParam, varargin)
%GLLPC GLL-PC

import org.mensxmachina.commons.*;
import org.mensxmachina.commons.stats.*;

% parse standard parameters
[x numLevels ord Param] = gllparamparse('ORG.MENSXMACHINA.PGM.GLLPC', a, varargin{:});

% check VAR
assert(ischar(var) || (isscalar(var) && ispositiveinteger(var)));
    
% find index of the variable
j = datasetind(a, var);

% call optimized version
[skeleton p stat flag Stats] = gllpcopt(x, numLevels, ord, j, InstParam, Param);

end