function [openQueue Stats] = initopenpcfirstqueueopt(~, ~, ~, j, ~, ~, ~, ~, ~, open, Stats, OpenQueueInitParam, ~)
%INITOPENPCFIRSTQUEUE Initialize OPEN PC-first priority queue

%   Copyright 2010-2011 Mens X Machina
%
%   This file is part of Mens X Machina Probabilistic Graphical Model
%   Toolbox.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is free software:
%   you can redistribute it and/or modify it under the terms of the GNU 
%   General Public License as published by the Free Software Foundation,
%   either version 3 of the License, or (at your option) any later version.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is distributed in
%   the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
%   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
%   PURPOSE. See the GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License along
%   with Mens X Machina Probabilistic Graphical Model Toolbox. If not, see
%   <http://www.gnu.org/licenses/>.

import org.mensxmachina.commons.graph.*;

% in order to work with mmpcopenupdateopt...
openQueue = struct('assocMin', NaN(size(open)), 'assocMinStat', NaN(size(open)));

openQueue.openParents = open(ismember(open, OpenQueueInitParam.ParentsInG{j}));
openQueue.openChildren = open(ismember(open, OpenQueueInitParam.ChildrenInG{j}));

end