function [tpc open openQueue Stats] = mmpcopenrmopt(~, ~, ~, ~, ~, ~, ~, ~, tpc, open, openQueue, Stats, ~, ~)
%RMMMPCOPENOPT remove from MMPC OPEN

%   Copyright 2010-2011 Mens X Machina
%
%   This file is part of Mens X Machina Probabilistic Graphical Model
%   Toolbox.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is free software:
%   you can redistribute it and/or modify it under the terms of the GNU 
%   General Public License as published by the Free Software Foundation,
%   either version 3 of the License, or (at your option) any later version.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is distributed in
%   the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
%   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
%   PURPOSE. See the GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License along
%   with Mens X Machina Probabilistic Graphical Model Toolbox. If not, see
%   <http://www.gnu.org/licenses/>.

% Max-min heuristic

if isempty(open)
    
    % nothing to remove
    return;
    
end

% get the index (among the remaining variables) and minimum association
% of the variable with the maximum minimum association
% among the remaining variables

assocminmax = -1;
statassocminmax = 0;

for j2IndInOpen = 1:numel(open) % for each variable in open

    if assoccmp(openQueue.assocMin(j2IndInOpen), openQueue.assocMinStat(j2IndInOpen), assocminmax, statassocminmax) > 0

        fIndInOpen = j2IndInOpen;
        assocminmax = openQueue.assocMin(j2IndInOpen);
        statassocminmax = openQueue.assocMinStat(j2IndInOpen);

    end        

end

% insert it in TPC(J)
tpc = [tpc open(fIndInOpen)];

% remove it from OPEN
open(fIndInOpen) = [];
openQueue.assocMin(fIndInOpen) = [];
openQueue.assocMinStat(fIndInOpen) = [];

end