function [tpc open openQueue Stats] = rmopenpcfirstopt(~, ~, ~, ~, ~, ~, ~, ~, tpc, open, openQueue, Stats, ~, ~)
%RMOPENPCFIRSTOPT Next variable from from OPEN, parents and children first

%   Copyright 2010-2011 Mens X Machina
%
%   This file is part of Mens X Machina Probabilistic Graphical Model
%   Toolbox.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is free software:
%   you can redistribute it and/or modify it under the terms of the GNU 
%   General Public License as published by the Free Software Foundation,
%   either version 3 of the License, or (at your option) any later version.
%
%   Mens X Machina Probabilistic Graphical Model Toolbox is distributed in
%   the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
%   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
%   PURPOSE. See the GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License along
%   with Mens X Machina Probabilistic Graphical Model Toolbox. If not, see
%   <http://www.gnu.org/licenses/>.

if isempty(open)
    
    % nothing to remove
    removed = [];
    
else
    
    if ~isempty(openQueue.openParents)
        
        % get next parent
        removed = openQueue.openParents(1); 
        
        % remove from open parents
        openQueue.openParents(1) = [];
        
    elseif ~isempty(openQueue.openChildren)
        
        % get next child
        removed = openQueue.openChildren(1); 
        
        % remove from open children
        openQueue.openChildren(1) = [];
        
    else
        
        % get next open
        removed = open(1);
        
    end
    
end

if ~isempty(removed)
    
    % remove them from OPEN
    open = setdiff(open, removed);

    % insert them in TPC(J)
    tpc = [tpc removed];
    
end

end