classdef TestSkeletonNfp < TestCase
%TESTSKELETONNFP SKELETONNFP test cases

properties
    TrueSkeleton
    Skeleton
    P
    TrueNfp
end

methods

function obj = TestSkeletonNfp(name)

obj = obj@TestCase(name);

obj.TrueSkeleton = [ ...
        0 1 1 0 ;
        1 0 0 1 ;
        1 0 0 1 ;
        0 1 1 0 ;
    ];
     
obj.TrueSkeleton = sparse(obj.TrueSkeleton);

obj.Skeleton = [ ...
        0 0 1 0 ;
        0 0 1 1 ;
        1 1 0 1 ;
        0 1 1 0 ;
    ];
     
obj.Skeleton = sparse(obj.Skeleton);

obj.P = [ ...
           1    0.06    0.01	0.06 ;
        0.06       1    0.03	0.02 ;
        0.01    0.03   	   1    0.04 ;
        0.06    0.02	0.04       1 ;
    ];

obj.TrueNfp = [ ...
        1       1       0       1 ;
        1       1       1       0 ;
        0       1   	1       1 ;
        1       0   	1       1 ;
    ];

obj.TrueNfp = obj.TrueNfp;

end

function testtoy(obj)
   
import org.mensxmachina.commons.graph.*;    
import org.mensxmachina.commons.stats.*;
import org.mensxmachina.pgm.*;

nonSkeletonInd = find(~obj.Skeleton);

p = obj.P;
p(nonSkeletonInd) = 0;
p = sparse(p);

trueV = obj.TrueNfp;
trueV(nonSkeletonInd) = 0;
trueV = sparse(trueV);

v = skeletonnfp(obj.Skeleton, p, obj.TrueSkeleton);

assertEqual(v, trueV);

% test thresholds
   
% convert skeleton matrix to vector
skeleton_vector = org.mensxmachina.commons.graph.skeleton2vector(obj.Skeleton);

% convert maximum p-value matrix to vector
p_vector = org.mensxmachina.commons.graph.skeleton2vector(p);
v_vector = org.mensxmachina.commons.graph.skeleton2vector(v);

% get edge linear indices in skeleton vector
skeleton_vector_ind = find(skeleton_vector);

% keep only maximum p-values corresponding to edges and convert to full
p_skeleton_vector = full(p_vector(skeleton_vector_ind));
v_skeleton_vector = full(v_vector(skeleton_vector_ind));

t_order = randperm(length(p_skeleton_vector));
t = p_skeleton_vector(t_order);
v_t = skeletonnfp(obj.Skeleton, p, obj.TrueSkeleton, t);
assertEqual(v_t, v_skeleton_vector(t_order));

end

end

end
