classdef TestSkeletonNp < TestCase
%TESTSKELETONNP SKELETONNP test cases

properties
    TrueSkeleton
    Skeleton
    P
    TrueNp
end

methods

function obj = TestSkeletonNp(name)

obj = obj@TestCase(name);

obj.Skeleton = [ ...
        0 0 1 0 ;
        0 0 1 1 ;
        1 1 0 1 ;
        0 1 1 0 ;
    ];
     
obj.Skeleton = sparse(obj.Skeleton);

obj.P = [ ...
           1    0.06    0.01	0.06 ;
        0.06       1    0.03	0.02 ;
        0.01    0.03   	   1    0.04 ;
        0.06    0.02	0.04       1 ;
    ];

obj.TrueNp = [ ...
        1     0     1     0 ;
        0     1     3     2 ;
        1     3     1     4 ;
        0     2     4     1 ;
    ];

obj.TrueNp = obj.TrueNp;

end

function testtoy(obj)
   
import org.mensxmachina.commons.graph.*;    
import org.mensxmachina.commons.stats.*;
import org.mensxmachina.pgm.*;

nonSkeletonInd = find(~obj.Skeleton);

p = obj.P;
p(nonSkeletonInd) = 0;
p = sparse(p);

trueNp = obj.TrueNp;
trueNp(nonSkeletonInd) = 0;
trueNp = sparse(trueNp);

np = skeletonnp(obj.Skeleton, p);

assertEqual(np, trueNp);

% test thresholds
   
% convert skeleton matrix to vector
skeleton_vector = org.mensxmachina.commons.graph.skeleton2vector(obj.Skeleton);

% convert maximum p-value matrix to vector
p_vector = org.mensxmachina.commons.graph.skeleton2vector(p);
np_vector = org.mensxmachina.commons.graph.skeleton2vector(np);

% get edge linear indices in skeleton vector
skeleton_vector_ind = find(skeleton_vector);

% keep only maximum p-values corresponding to edges and convert to full
p_skeleton_vector = full(p_vector(skeleton_vector_ind));
np_skeleton_vector = full(np_vector(skeleton_vector_ind));

t_order = randperm(length(p_skeleton_vector));
t = p_skeleton_vector(t_order);
np_t = skeletonnp(obj.Skeleton, p, t);
assertEqual(np_t, np_skeleton_vector(t_order));

end

function testempty(obj)
   
import org.mensxmachina.pgm.*;    
    
np = skeletonnp(sparse(4, 4), sparse(4, 4));

assertEqual(np, sparse(4, 4));
    
end

end

end